/******************************************************************************
*  Πρόγραμμα οδήγησης αναλογικού μοχλού 2 αξόνων με πλήκτρο στιγμιαίας επαφής
*  ΣΥΝΔΕΣΜΟΛΟΓΙΑ
*  VRx  - αναλογικό κανάλι Α0
*  VRy – αναλογικό κανάλι Α1
*  SW – Ψηφιακό κανάλι 2
*   *****************************************************************************/
// Ορισμός ακροδεκτών που θα συνδεθεί ο μοχλός
int VRx =   A0;
int VRy = A1;
int SW = 2;

void setup(void)
{
// Ρύθμιση του ακροδέκτη SW σε ψηφιακή είσοδο με ενεργοποιημένη την αντίσταση pull-up
  pinMode(SW,INPUT_PULLUP);
 // Ρύθμιση της μονάδας σειριακής επικοινωνίας για έξοδο στο τερματικό
  Serial.begin(9600); 
}
void loop(void)
{    
// Σε κάθε επανάληψη κάνε μέτρηση της στάθμης στα αναλογικά κανάλια που έχουν συνδεθεί
// οι ακροδέκτες VRx και VRy του αναλογικού μοχλού
int adc_vrx_value = analogRead(VRx);
int adc_vry_value = analogRead(VRy);
// η τιμή της στάθμης των αναλογικών καναλιών κυμαίνεται από 0-1023 που αντιστοιχούν σε 0-5V
// κάνε μετατροπή της κλίμακας 0-1023 σε 0-5V
float voltage_X = (adc_vrx_value * 5.0f)/1023.0f;
float voltage_Y = (adc_vry_value * 5.0f)/1023.0f;

// εμφάνισε το αποτέλεσμα στο τερματικό σε μορφή τάσης  "Vx=xxV      Vy=xxV”
Serial.print("Vx = ");
Serial.print(voltage_X);
Serial.print(" V      ”);
Serial.print("Vy = ");
Serial.print(voltage_Y);
Serial.println(" V ”);
// κάνε έλεγχο αν πατήθηκε το πλήκτρο 
if (digitalRead(SW) == LOW)
    Serial.println("Το πλήκτρο είναι πατημένο");
}
