/**********************************************************************
*  Πρόγραμμα μέτρησης της έντασης της μαγνητικής ροής ενός μαγνήτη με ανίχνευση
*  της πολικότητας του μαγνήτη.
*   Ο αισθητήρας SS490 συνδέεται με τον ακροδέκτη Α0 της μονάδας Arduino UNO
*   Οι τιμές εμφανίζονται στο σειριακό τερματικό.
***********************************************************************/
// Ορισμός του ακροδέκτη που θα συνδεθεί ο αισθητήρας με τη μονάδα Arduino UNO
#define SS490_OUT    A0

void setup(void)
{

 // Ρύθμιση του τερματικού για απεικόνιση πληροφοριών
  Serial.begin(9600); 
}

void loop(void)
{ 
   // μεταβλητή που θα αποθηκεύει την τιμή της έντασης της μαγνητικής ροής σε gauss
   float Gauss = 0.0f;
  // Σε κάθε επανάληψη κάνε ανάγνωση της μέτρησης στο αναλογικό κανάλι
  uint16_t adcRead = analogRead(SS490_OUT);  
  // κάνε μετατροπή της μέτρησης σε τιμή τάσης
  float voltage = (adcRead * 5.0f)/1024.0f;  
  // Κάνε χρήση της συνάρτησης μεταφοράς για τον υπολογισμό της τιμής σε Gauss 
  Gauss =(voltage – 2.5f)/ (0.000625f * 5.0f); 
  // αν η τιμή που υπολογίσαμε από την συνάρτηση μεταφοράς είναι θετική
  If (Gauss > 0)
  {
     // Εκτύπωσε την τιμή στο τερματικό και ενημέρωσε ότι ανιχνεύτηκε ο Νότιος Μαγνητικός Πόλος
     Serial.print("SOUTH POLE -  ");
     Serial.print(Gauss);
     Serial.println(" Gs");
 }
 // αν η τιμή που υπολογίσαμε από την συνάρτηση μεταφοράς είναι αρνητική
 If (Gauss < 0)
  {
     // Εκτύπωσε την τιμή στο τερματικό και ενημέρωσε ότι ανιχνεύτηκε ο Βόριος Μαγνητικός Πόλος
     Serial.print("NORTH POLE -  ");
     Serial.print(Gauss);
     Serial.println(" Gs");
 }
// Καθυστέρησε την επόμενη μέτρηση 200 ms
  delay(200);
}
