/**********************************************************************
*  Πρόγραμμα οδήγησης lcd οθόνης 16x2 (HD44780)
*  με την αναπτυξιακή μονάδα Arduino UNO
*   ***********************************************************************/
// Συμπεριλαμβάνουμε την βιβλιοθήκη οδήγησης της οθόνης LCD
#include <LiquidCrystal.h>

// Ορισμός των ακροδεκτών οδήγησης της οθόνης
int LCD_RS  = 2 ;
int LCD_E  =  3;
int LCD_D4  =  4;
int LCD_D5  =  5;
int LCD_D6  =  6;
int LCD_D7  =  7;
ind LCD_LED = 8;

// Δημιουργούμε ένα αντικείμενο της κλάσης LiquidCrystal με όνομα lcd 
// και θέτουμε στις παραμέτρους τους ακροδέκτες που έχουμε ορίσει 
// για την οδήγηση της οθόνης σύμφωνα με το κυκλωματικό διάγραμμα
LiquidCrystal lcd (LCD_RS, LCD_E, LCD_D4, LCD_D5, LCD_D6, LCD_D7);

void setup(void)
{
  // Ρυθμίζουμε την οθόνη LCD ορίζοντας τον αριθμό των χαρακτήρων και των γραμμών
  // που αυτή υποστηρίζει καλώντας την ιδιότητα begin του αντικειμένου lcd που δημιουργήσαμε.
  // Στο παράδειγμά μας έχουμε οθόνη 16 χαρακτήρων και 2 γραμμών
  lcd.begin (16, 2);
  // εμφάνισε ένα μήνυμα στην πρώτη γραμμή (0) της οθόνης
  lcd.print ("my LCD message");
  // θέσε τον κέρσορα στην αρχή (0) της δεύτερης γραμμής (1)
  lcd.setCursor(0,1);
  // εμφάνισε ένα μήνυμα στην δεύτερη γραμμή (1) της οθόνης
  lcd.print ("second line msg");
}

void loop()
{    
}
