/**********************************************************************
*  Πρόγραμμα οδήγησης των μονάδων Arduino UNO, το ίδιο πρόγραμμα πρέπει
*  να φορτωθεί και στις δύο μονάδες Arduino
************************************************************************/
// μεταβλητή που θα κρατά τα δεδομένα που έρχονται από τη σειριακή θύρα UART
String serialBuffer = "";
// μεταβλητή που θα δηλώνει αν ολοκληρώθηκε η λήψη δεδομένων στη σειριακή θύρα UART
bool receiveComplete = false;
// μεταβλητή που θα κρατά την κατάσταση του LED της συσκευής που βρίσκεται συνδεδεμένη
// στην άλλη πλευρά της γραμμής επικοινωνίας
int LedValue = 0;
// δήλωσε τον ακροδέκτη που θα συνδεθεί το LED
int LED = 13;
// δήλωσε τον ακροδέκτη που θα συνδεθεί το πλήκτρο
int BTN = 2;

void setup(void)
{
       // ρύθμισε τον ακροδέκτη που συνδέεται το LED σε έξοδο και σβήσε το LED
       pinMode(LED,OUTPUT);
       digitalWrite(LED,LOW);
       // ρύθμισε τον ακροδέκτη που συνδέεται το πλήκτρο σε είσοδο με ενεργοποιημένη την εσωτερική
       // αντίσταση Pull Up
       pinMode(BTN,INPUT_PULLUP);

       // κάνουμε χρήση της σειριακής επικοινωνίας UART με BaudRate 9600
       // το Baud Rate θα πρέπει να είναι ίδιο και στις δύο μονάδες
       Serial.begin(9600);
      // δέσμευσε χώρο για τα δεδομένα του καταχωρητή λήψης UART
       serialBuffer.reserve(200);
}

void loop()
{    
          // σε κάθε επανάληψη κάνε έλεγχο αν έχουμε λάβει δεδομένα από τη
         // μονάδα UART που σημαίνει πως τα δεδομένα έφτασαν ασύρματα
         // από την απομακρυσμένη συσκευή XBEE που μετρά την θερμοκρασία 
         if (receiveComplete)
         {
            // τα δεδομένα είναι σε μορφή συμβολοσειράς μέσα στη μεταβλητή 
            // serialBuffer. 
            // αν η συμβολοσειρά που λήφθηκε από την σειριακή θύρα είναι "LED_ON"
            if (serialBuffer == "LED_ON")
            {
                  // άναψε το LED στην πλακέτα
                  digitalWrite(LED,HIGH);
            }
            // αν η συμβολοσειρά που λήφθηκε από την σειριακή θύρα είναι "LED_OFF"
            else if (serialBuffer == "LED_OFF")
            {
                   // σβήσε το LED στην πλακέτα
                   digitalWrite(LED,LOW);

            }
            // μηδένισε τη μεταβλητή για επόμενο έλεγχο λήψης
            receiveComplete = false;
            // καθάρισε μεταβλητή για επόμενο έλεγχο λήψης
            serialBuffer = "";
         }

          // σε κάθε επανάληψη κάνε έλεγχο αν o χρήστης έχει πατήσει το κουμπί
         if ( (digitalRead(BTN) == LOW) && (buttonPressed == false) )
         {
             // καθυστέρηση για αποφυγή της αναπήδησης του πλήκτρου
             delay(250);
             // αν το κουμπί είναι ακόμα πατημένο
             if ( (digitalRead(BTN) == LOW) && (buttonPressed == false) )
             {
                   // δήλωσε πως το πλήκτρο πατήθηκε
                   buttonPressed = true;
                   // κάθε φορά θέσε την τιμή της μεταβλητής στην αντίθετη τιμή από ότι ήταν πριν
                   Ledvalue ^= 1;
                   // ανάλογα με την τιμή της μεταβλητής στείλε το ανάλογο μήνυμα στην σειριακή διεπαφή
                   if (LedValue == 1)
                      Serial.println("LED_ON");
                   else if (LedValue == 0)
                      Serial.println("LED_OFF");
             }
         }

         // σε κάθε επανάληψη κάνε έλεγχο αν o χρήστης έχει απελευθερώσει το κουμπί
         // ενώ το έχει πατήσει
         if ( (digitalRead(BTN) == HIGH) && (buttonPressed == true) )
         {
            // καθυστέρηση για αποφυγή της αναπήδησης του πλήκτρου
             delay(250);
            // αν το κουμπί είναι απελευθερωμένο 
            if ( (digitalRead(BTN) == HIGH) && (buttonPressed == true) )
                    //  θέσε τη μεταβλητή σε false για επόμενο έλεγχο πατήματος 
                    buttonPressed = false;
         }         
}

// εκτελείται σε κάθε επανάληψη σύμφωνα με το reference της πλατφόρμας
// arduino
void serialEvent()
{
   while(Serial.available())
   {
      // κάνε ανάγνωση του χαρακτήρα που ήρθε στη σειριακή θύρα
      char inputChar = (char)Serial.read();
      // αν ο χαρακτήρας που αναγνώσαμε είναι ο τερματικός χαρακτήρας 
      if (inputChar == '\n')
            // δήλωσε πως η λήψη ολοκληρώθηκε
            receiveComplete = true;
   }
}
