/**********************************************************************
 *  Πρόγραμμα μέτρησης θερμοκρασίας με τον αισθητήρα DS18B20
*   Ο αισθητήρας συνδέεται με τον ακροδέκτη 2
*   Μετρά τη θερμοκρασία και εμφανίζει την τιμή στο τερματικό κάθε
*   1 δευτερόλεπτο.
***********************************************************************/
// Συμπεριλαμβάνουμε την βιβλιοθήκη με το πρωτόκολλο OneWire
#include <OneWire.h>
// Συμπεριλαμβάνουμε βιβλιοθήκη που περιέχει χρήσιμες συναρτήσεις
// υπολογισμού της θερμοκρασίας
#include <DallasTemperature.h>

// Ορισμός του ακροδέκτη που θα συνδεθεί ο αισθητήρας με τη μονάδα Arduino UNO
#define ONE_WIRE_BUS 2
// Ορισμός ενός αντικειμένου για το χειρισμό του πρωτοκόλλου OneWire
OneWire oneWire(ONE_WIRE_BUS);
// Χρησιμοποίησε το αντικείμενο που δημιουργήσαμε στη βιβλιοθήκη υπολογισμών
// της θερμοκρασίας για τον αισθητήρα DS18B20 
DallasTemperature sensors(&oneWire);

void setup(void)
{

 // Ρύθμιση του τερματικού για απεικόνιση πληροφοριών
  Serial.begin(9600); 
// Αρχικοποίησε τον αισθητήρα θερμοκρασίας
  sensors.begin();
}

void loop(void)
{ 
  // Στείλε την εντολή στον αισθητήρα για να λάβουμε τη θερμοκρασία
  sensors.requestTemperatures();  
 // Εμφάνισε στο τερματικό την τιμή της θερμοκρασίας
  Serial.print("Temperature =  ");
// Κάνε ανάγνωση της τιμής της θερμοκρασίας από τον αισθητήρα με δείκτη 0 και εμφάνισε
// το αποτέλεσμα της θερμοκρασίας στο τερματικό.
  Serial.println(sensors.getTempCByIndex(0)); 
// Καθυστέρησε την μέτρηση 1 δευτερόλεπτο μέχρις ότου εκτελέσουμε νέα μέτρηση
  delay(1000);
}
