/***********************************************************************************
*  Πρόγραμμα οδήγησης επιταχυνσιομέτρου και γυροσκοπίου 3ών αξόνων με τη μονάδα MPU6050
*   *********************************************************************************/
// Συμπεριλαμβάνουμε τις βιβλιοθήκες για την οδήγηση της μονάδας MPU6050 
#include "I2Cdev.h”
#include "MPU6050.h”
#include "Wire.h”

// Δημιουργούμε ένα αντικείμενο της κλάσης MPU6050 για να έχουμε πρόσβαση στις μεθόδους
// και τα χαρακτηριστικά αυτής της κλάσης.
MPU6050 accel_gyro;

// Δηλώνουμε τις μεταβλητές που θα κρατούν τις τιμές των αξόνων για το επιταχυνσιόμετρο
int16_t acX, acY, acZ;
// Δηλώνουμε τις μεταβλητές που θα κρατούν τις τιμές των αξόνων για το γυροσκόπιο
int16_t gyrX, gyrY, gyrZ;

void setup(void)
{
  // Αρχικοποιούμε την επικοινωνία I2C μέσω της βιβλιοθήκης wire
  Wire.begin();
  // Αρχικοποιούμε την μονάδα MPU6050
  accel_gyro.initialize();
  // Ρύθμιση της μονάδας σειριακής επικοινωνίας για έξοδο στο τερματικό
  Serial.begin(9600); 
}

void loop(void)
{    
// σε κάθε επανάληψη αυτού του βρόγχου κάνε ανάγνωση των τιμών του επιταχυνσιομέτρου 
accel_gyro.getAcceleration(&acX, &acY, &acZ);
// κάνε ανάγνωση και των τιμών του γυροσκοπίου 
accel_gyro.getRotation(&gyrX, &gyrY, &gyrZ);

// εμφάνισε τα αποτελέσματα στο τερματικό 
Serial.println("Accelerometer XYZ:”);
Serial.print("acX= "); Serial.print(acX); Serial.print("   acY= "); Serial.print(acY); Serial.print("   acZ= ");
Serial.println(acZ);
Serial.println("Gyroscope XYZ:”);
Serial.print("gyrX= "); Serial.print(gyrX); Serial.print("   gyrY= "); Serial.print(gyrY); Serial.print("   gyrZ= ");
Serial.println(gyrZ);
}
